<?php

/**
 * @file
 * Service related strings that needs to be translated at runtime.
 */

t('head');
t('neck');
t('shoulder');
t('back');
t('chest');
t('wrist');
t('hands');
t('waist');
t('legs');
t('feet');
t('finger1');
t('finger2');
t('trinket1');
t('trinket2');
t('mainHand');
t('offHand');
t('ranged');

/**
 * Implements hook_wow_data_resources().
 */
function wow_character_wow_data_resources() {
  return array(
    'wow_character' => array(
      'races' => array(
        'name' => t('Character Races'),
        'description' => t('The character races data API provides a list of character races.'),
        'remote path' => 'character/races',
        'fetch class' => 'CharacterRace',
        'refresh threshold' => 2592000, // 30 days.
      ),
    ),
  );
}

/**
 * Refresh callback for the character races resources.
 *
 * @param object $service
 *  The WoW Data Service.
 * @param array $items
 *   An array of items to import.
 */
function wow_character_races_refresh($langcode) {
  $rids = db_query('SELECT id FROM {wow_character_races} WHERE language = :language', array(':language' => $service->language))->fetchAllAssoc('id');
  foreach ($items as $race) {
    // Convert side: horde(0) or alliance(1)
    $race->side = $race->side == 'horde';
    $race->language = $langcode;

    if (array_key_exists($race->id, $rids)) {
      // We have this string saved already.
      $success = drupal_write_record('wow_character_races', $race);
    }
    else {
      $success = drupal_write_record('wow_character_races', $race, array('id', 'language'));
    }

    if ($success == SAVED_NEW) {

    }
  }

  // Return results of this import.
  return $report + array('language' => $langcode);
}
